# Komodo 
Имеет ряд дополнительных функций, отладка кода (включая удаленную), рефакторинг, работа с VCS, HTTP Inspector, Rx Toolkit, интегативный шелл, юнит-тесты, интеграцию с другими продуктами компании (Stackato, Perl Dev Kit и TCL Dev Kit) и другие мелочи.

Для Ruby on Rails есть встроенный bundle, если нажать Ctrl+Shift+K то можно быстро запустить команду из rake. Для отладки django приложений из IDE, нужно запустить сервер без поддержки threads.

##### Удаленное редактирования кода

  

В отличие от Netbeans или IDEA, не происходит полная синхронизация удаленного кода локально. Доступны следующие протоколы: FTP, FTPS, SFTP, SCP.  
  
![](https://habrastorage.org/r/w1560/getpro/habr/post_images/f1c/557/e74/f1c557e745a3ce7cd4ac68675285b6e1.png)  
  

##### Отладка

  
Отладка кода сделана очень хорошо. Есть удаленная отладка. Отладчик это самая полезная фича, которая есть в Komodo IDE, особенно для разработки на Perl. 
  
![](https://habrastorage.org/r/w1560/getpro/habr/post_images/ce1/9c7/e1a/ce19c7e1aad53012638c39aaf4af802e.png)  
  
##### Системы контроля версий

  
Поддерживаются Mercurial, Bazaar, Git, CVS, SVN, Perforce.  
Сочетания клавиш настраиваются в Preferences — Shortcuts.  
Подсветки измененных частей кода в реальном времени нет.
  
##### Ящик для инструментов

![Ящик для инструментов](https://coderlessons.com/wp-content/uploads/images/stp/42816463c932fb5700c70f8d9ba85b54.png)

Панель инструментов –  позволяющая хранить фрагменты кода, макросы JavaScript, шаблоны или даже URL-адреса на боковой панели для быстрого доступа. 

Чтобы открыть панель инструментов, перейдите в Вид -> Вкладки и боковые панели -> Панель инструментов.  По умолчанию инструменты подразделяются на три папки: верхний уровень – это глобальный набор инструментов, а два дополнительных набора инструментов – это общий и набор инструментов проекта.  Вы можете создать столько дополнительных папок панели инструментов, сколько пожелаете.
##### Код разведки

![Code Intelligence](https://coderlessons.com/wp-content/uploads/images/stp/f81b9e025daab06a5a118c101985aed4.png)

Интеллектуальный анализ кода в Komodo IDE не ограничивается заполнением имен ваших методов и свойств, он также имеет возможности рефакторинга кода и интеллектуальные преобразования кода, такие как переименование переменных и извлечение методов.

Браузер кода и определения переходов также являются частью кода IDE.  Браузер кода позволяет перемещаться по источнику в древовидном представлении, и щелчок по одному из методов или свойств приведет к переходу к этой строке в файле. 

![Code Browser](https://coderlessons.com/wp-content/uploads/images/stp/4311ccfc35c8fe15d888f8947a0bf542.png)

**Подсветка синтаксиса**
Komodo IDE поддерживает множество языков.  Просто нажмите на нижнюю панель «Тип файла», чтобы выбрать / отменить выбор нескольких языков.

![Language mixing](https://coderlessons.com/wp-content/uploads/images/stp/b05134c729480fe48be66ebc951ceaa8.png)


**Split View**  – позволяющая открывать несколько файлов в режиме разделенного экрана.  Это полезно, если вы хотите сделать сравнение между различными файлами или открыть несколько типов файлов по отдельности, например, PHP на одной панели, HTML или CSS на другой.

![Split view](https://coderlessons.com/wp-content/uploads/images/stp/707ffbb6182ef56afcaa90948611c44d.png)

Komodo IDE очень гибок в настройке.  Каждый вид, значок и раздел могут быть настроены в соответствии с вашими потребностями.

##### Интерактивный терминал

Доступен интерактивный шелл на Python, Perl, Ruby и TCL. 
  
![](https://habrastorage.org/r/w1560/getpro/habr/post_images/a2a/569/ba9/a2a569ba964611a623692573f00bfe27.png)  
если нажать Ctrl+R и написать cmd.exe, то таким образом получается еще и виндовый терминал.  
![](https://habrastorage.org/r/w1560/getpro/habr/post_images/92d/2df/f2f/92d2dff2ff23ec25192dd39028376825.png)  
  

##### Toolbox

Если вы часто повторяете какую-то последовательность действий, то можно записать их в виде макроса (подобно в Excel) или запрограммировать на javascript. А потом запускать через Toolbox.    
![](https://habrastorage.org/r/w1560/getpro/habr/post_images/f32/ddd/7c5/f32ddd7c584cc37f56d6a6158c82074c.png)  
  

##### Collaboration режим

  
В этом режиме можно работать над одним и тем же кодом совместно, как в Google Docs.  
  

##### Database explorer

  
Разработчиками заявлена поддержка SQLite, MySQL, Oracle. Для работы с MySQL и Oracle нужно установить расширения.  
  

##### Юнит-тестирование

  
Вначале нужно создать тест-план, который в дальнейшем вызывается в IDE. Поддерживаются TAP, PHPUnit, unittest, Rake::Test, tcltest, Rake tests.  
  
![](https://habrastorage.org/r/w1560/getpro/habr/post_images/f1d/bc5/214/f1dbc5214bc8ece85bd327590054a423.png)  
##### Рефакторинг и форматирование

  
Рефакторинг появился совсем недавно. Есть возможность переименовывать переменные и методы класса.  
По хоткею можно запустить js tidy или выровнять отступы.

##### Regex Toolkit
Запускается в отдельном окне и может помочь визуально протестировать ваши регулярные выражения.  
##### HTTP Inspector
Реализован в виде HTTP прокси.  
  
![](https://habrastorage.org/r/w1560/getpro/habr/post_images/6e2/25b/a96/6e225ba968732856634ceedbeee4e44d.png)  
Поддерживаются пользовательские правила: 
![](https://habrastorage.org/r/w1560/getpro/habr/post_images/ec7/e4b/362/ec7e4b362fa83bba86a2e6cdbb35e20f.png)  
  

##### Поддержка расширений

  
Komodo поддерживает сторонние расширения.  
Диалог стандартный, который пришел из Firefox.  
В каталоге есть Zen Coding, PEP-8 syntax checker, D Language и еще много других.
![](https://habrastorage.org/r/w1560/getpro/habr/post_images/e58/b95/452/e58b954520ab9c4ee07b50e1ba179733.png)  
  
## Популярные расширения Komodo IDE

### NST
Новое исходное дерево
С домашней страницы расширений: «Если вы работаете над большими проектами, очень трудно не потеряться в вашем коде без приличной карты.  NST предоставляет его аналогично браузеру кодов Komodo ».

Он предоставляет новую панель для визуализации вашего исходного кода.  Перейдите в  _View -> Tabs & Sidebars -> Source,_  чтобы включить его.

![nst extension](https://coderlessons.com/wp-content/uploads/images/stp/4e453c8a2318db0ffe9e4c3a60860a83.png)

### Side by Side Diff
«Side-by-Side Diff»
это дополнение к обычному диалоговому окну «diff», позволяющее видеть изменения бок о бок.

Когда вы активируете диалоговое окно diff – перейдя в  _File -> Source Code Control -> Diff (Compare Files)_  – вы увидите раскрывающееся меню под названием  _Diff style, в_  котором вы можете включить параллельное представление diff.

![side-by-side-diff](https://coderlessons.com/wp-content/uploads/images/stp/12c3725935cd2e3d192f339f4e419c05.png)

### MySQL Database Explorer

Komodo IDE имеет встроенные возможности проводника баз данных, но в его ядре нет драйвера MySQL.  С этим расширением вы можете добавить эту функциональность, позволяя подключаться к базам данных MySQL.

После того, как расширение установлено, перейдите в  _View -> Tabs & Sidebars -> Databases_  , нажмите на знак «+» слева и создайте новое соединение с базой данных для MySQL во всплывающем окне.

![MySQL explorer](https://coderlessons.com/wp-content/uploads/images/stp/fd0b71267d4798302bae274345e78d2a.png)

### ТОДО Хелпер

Это действительно полезное расширение, оно анализирует файл, который вы открыли в данный момент, и показывает, есть ли какие-либо комментарии.

Маленький значок в строке состояния покажет вам, есть ли какие-либо задачи, щелкните по нему, и откроется панель Todo.  Вы можете определить шаблон поиска для строк todo в файле.

![todo helper](https://coderlessons.com/wp-content/uploads/images/stp/b9ab7bcef53db77593b024e82ef5312d.png)